/** Ticket
 *
 * This class represents a "ticket". Note that it maps to the ticket CFC.
 */
package com.adobe.actors
{
	//[RemoteClass(alias="SupportTicket.cfc.tickets")]

	[Bindable]
	public dynamic class Ticket
	{

		public var id:Number = 0;
		public var create_dt:Date;
		public var customer_id:Number = 0;
		public var assigned_engineer_id:Number = 0;
		public var description:String = "";
		public var status:String = "Open";
		public var action:String = "Call Back";
		public var priority:String = "14";
		public var product_name:String = "";
		public var product_version:String = "";
		public var product_language:String = "";
		public var disposition:String = "";
		public var summary:String = "";
		public var operating_system:String = "";
		public var web_server:String = "";
		public var web_browser:String = "";
		public var app_server:String = "";
		
		public var customer_info:Customer;
		public var engineer:Engineer;


		public function Ticket()
		{
		}
		
		/**
		 * copy
		 *
		 * Makes a copy of the given Ticket and returns it.
		 * Note: does not do a deep copy of the Engineer or Customer parts.
		 */
		
		static public function copy( src:Ticket, dest:Ticket=null ) : Ticket
		{
			if( dest == null ) dest = new Ticket();
			
			dest.id = src.id;
			dest.create_dt = src.create_dt;
			dest.customer_id = src.customer_id;
			dest.assigned_engineer_id = src.assigned_engineer_id;
			dest.description = src.description;
			dest.status = src.status;
			dest.action = src.action;
			dest.priority = src.priority;
			dest.product_name = src.product_name;
			dest.product_version = src.product_version;
			dest.product_language = src.product_language;
			dest.disposition = src.disposition;
			dest.summary = src.summary;
			dest.operating_system = src.operating_system;
			dest.web_server = src.web_server;
			dest.web_browser = src.web_browser;
			dest.app_server = src.app_server;
			
			dest.customer_info = src.customer_info;
			dest.engineer = src.engineer;
			
			return dest;
		}

	}
}