<?php 
/**
 * getAllTicketsForEngineer
 * Requests all of the tickets assigned to the given engineer
 *
 * Initial version : 13 Nov 2006
 * by PhilFlash - http://philflash.inway.fr
 */
 	require_once('connectdb.php');

    // ----- NO CACHE -----
	session_cache_limiter('nocache');

	// General header for no caching
	$now = gmdate('D, d M Y H:i:s') . ' GMT';
	header('Expires: ' . $now); // rfc2616 - Section 14.21
	header('Last-Modified: ' . $now);
	header('Cache-Control: no-store, no-cache, must-revalidate, pre-check=0, post-check=0, max-age=0'); // HTTP/1.1
	header('Pragma: no-cache'); // HTTP/1.0

 	header("Content-Type: text/xml; charset=utf-8");

	// ----- Functions -----
	function formatAttributeValue($theValue) {
		$theValue = utf8_encode($theValue);
    	return $theValue;
    }

	function formatTagValue($theValue) {
		if ($theValue == "") {
			return "";
		}
	 	$theValue =	htmlspecialchars($theValue, ENT_COMPAT);
		$theValue = str_replace("'", "&apos;", $theValue);
		$theValue = utf8_encode($theValue);
    	return $theValue;
    }
    
    function isISODate($sdate) {
    	// 2006-12-23 12:12:23
    	if (strlen($sdate) != 19) {
    		return 0;
    	}
  		$myyear = substr($sdate,0,4);
  		$mymonth = substr($sdate,5,2);
  		$myday = substr($sdate,8,2);
  		$myhour = substr($sdate,11,2);
  		$mymin = substr($sdate,14,2);
  		$mysec = substr($sdate,17,2);
		$time1 = mktime($myhour, $mymin, $mysec, $mymonth, $myday, $myyear);
		$date2 = date("Y-m-d H:i:s", $time1);
		return ($date2 == $sdate ? 1 : 0);
	}
	// ----- MySQL Connection -----
	mysql_select_db($database_db, $connect_db);
	
	// ----- Check Parameter -----
	if (isset($_GET['id'])) {
		$value = $_GET['id'];
		if (is_numeric ($value)) {
			$engineerID = intval($value);
		} else {
			$engineerID = 0;
		}
		if ($engineerID < 0) $engineerID = 0;
	} else {
		$engineerID = 0;
	}
	
	// -- check date --
	$startDate = "";
	if (isset($_GET['d1'])) {
		$startDate = $_GET['d1'];
		if (isISODate($startDate) == 0) {
			$startDate = "";
		}
	} 
	
	$endDate = "";
	if (isset($_GET['d2'])) {
		$endDate = $_GET['d2'];
		if (isISODate($endDate) == 0) {
			$endDate = "";
		}
	} 
	
	$conditions = "";
	if ($startDate != "" && $endDate != "") {
		$conditions = " and '".$startDate."' <= create_dt and create_dt <= '".$endDate."'";
	}
	
	// ----- SQL command -----
	$query = "SELECT id, customer_id,create_dt,assigned_engineer_id,description,status,action,priority,"
		. "product_name,product_version,product_language,operating_system,web_browser,web_server,app_server,"
		. "disposition,summary FROM st_tickets where assigned_engineer_id = ".$engineerID.$conditions;
		
	$recordset = mysql_query($query, $connect_db) or die(mysql_error());

	// create document object
	$dom = new DOMDocument();
	$dom->loadXML("<?xml version=\"1.0\" encoding=\"UTF-8\" ?><list></list>");

	$rootNode = $dom->documentElement;
	
	while ($row_recordset = mysql_fetch_array($recordset)) {

		// create item node
		$record = new DOMElement("ticket", "");
		$rootNode->appendChild($record);
		
		$record->setAttribute("id", $row_recordset[0]);
		$record->setAttribute("customer_id", $row_recordset[1]);
		$record->setAttribute("create_dt", formatAttributeValue($row_recordset[2]));
		$record->setAttribute("assigned_engineer_id", $row_recordset[3]);
		
		$record->setAttribute("description", formatAttributeValue($row_recordset[4]));	
		$record->setAttribute("status", formatAttributeValue($row_recordset[5]));
		$record->setAttribute("action", formatAttributeValue($row_recordset[6]));	
		$record->setAttribute("priority", formatAttributeValue($row_recordset[7]));
		
		$record->setAttribute("product_name", formatAttributeValue($row_recordset[8]));	
		$record->setAttribute("product_version", formatAttributeValue($row_recordset[9]));
		$record->setAttribute("product_language", formatAttributeValue($row_recordset[10]));	
		$record->setAttribute("operating_system", formatAttributeValue($row_recordset[11]));
		
		$record->setAttribute("web_browser", formatAttributeValue($row_recordset[12]));	
		$record->setAttribute("web_server", formatAttributeValue($row_recordset[13]));
		$record->setAttribute("app_server", formatAttributeValue($row_recordset[14]));	
		$record->setAttribute("disposition", formatAttributeValue($row_recordset[15]));
		$record->setAttribute("summary", formatAttributeValue($row_recordset[16]));
	}

	mysql_free_result($recordset);
	mysql_close();

	// print the XML
	print $dom->saveXML();
?>
