<?php 
/**
 * Save or update a ticket
 * If a note is passed, attach the note to the ticket.
 * 
 * Initial version : 13 Nov 2006
 * by PhilFlash - http://philflash.inway.fr
 */
	require_once('connectdb.php'); 

	// For debug
	// If true, save the XML in the file debugOperation.xml
	// To test, enter: opticket.php?debug=1 => read the file debugOperation.xml
	$debugXmlOperation = true;
									
    // ----- NO CACHE -----
	session_cache_limiter('nocache');
  
	// General header for no caching
	$now = gmdate('D, d M Y H:i:s') . ' GMT';
	header('Expires: ' . $now); // rfc2616 - Section 14.21
	header('Last-Modified: ' . $now);
	header('Cache-Control: no-store, no-cache, must-revalidate, pre-check=0, post-check=0, max-age=0'); // HTTP/1.1
	header('Pragma: no-cache'); // HTTP/1.0
	
 	header("Content-Type: text/xml; charset=utf-8");
	// ----- Functions -----
	function sqlFormatString($str) {
		$str = utf8_decode($str); 
		// Stripslashes
		if (get_magic_quotes_gpc()) {
			$str = stripslashes($str);
		}
		return "'".mysql_real_escape_string($str)."'";
	}
	
	// if not a numeric value, format the string
	function sqlFormatNumber($str) {
		return (is_numeric($str) ? $str : sqlFormatString($str));
	}

	// ----- MySQL Connection -----
	mysql_select_db($database_db, $connect_db);
	
	// ----- Read operation in XML -----	
	$xmlOperation = "";
	$domOperation = new DOMDocument();
	
	if (isset($debug) && $debug == "1") {
		$domOperation->load("debugOperation.xml");
	} else {
		$xmlOperation = file_get_contents("php://input");
		if ($xmlOperation == "") {
			// die("*** WAIT A PARAMS XML FILE ***");
			$xmlOperation = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?><params></params>";
		}
		$domOperation->loadXML($xmlOperation);
		
		if ($debugXmlOperation) {
			$fp = fopen("debugOperation.xml", "w");
			fwrite($fp, $domOperation->saveXML());
			fclose($fp);
		}
	}
	
	// ----- Prepare XML to send -----
	$dom = new DOMDocument();
	$dom->loadXML("<?xml version=\"1.0\" encoding=\"UTF-8\" ?><roperation></roperation>");
	
	$rcode =  0; // 0:bad operation, 1: ok
	$rarg =   ""; // arg returned
	$errmsg = ""; // error message
	$noteid = "";
	
	$rootNode = $dom->documentElement;
	
	// ----- Check operation -----
	$nodeOperation = $domOperation->documentElement;
	
	$operation = $nodeOperation->getAttribute("opcode");
	
	$ticketIDforNote = -1;
	
	
	// -- process "update" operation --
	if ($operation == "update") {

    	$valuesNode = $nodeOperation->getElementsByTagName("values");
    	$valueNode = $valuesNode->item(0);
    	
    	$updateStmt = "";
    	$updateCondition = "";
    	
   		if ($valueNode->hasAttributes()) {
   			$addStmt = "";
       		foreach ($valueNode->attributes as $attribute) {
       			$name = $attribute->name;
       			$value = $attribute->value;
       			
				switch ($name) {
					case "description";
					case "status";
					case "action";
					case "priority";
					case "product_name";
					case "product_version";
					case "product_language";
					case "disposition";
					case "summary";
					case "operating_system";	
					case "web_server";
					case "web_browser";
					case "app_server";
						// string
						$updateStmt .= $addStmt . "`" . $name . "` = " . sqlFormatString($value);
						$addStmt = ",";
						break;

					case "create_dt";
						// date de cration -> on ne modifie rien
						break;
						
					case "id";
						if (is_numeric ($value)) {
							$ticketID = intval($value);
						} else {
							$ticketID = -1;
						}
						$updateCondition = 	$name . " = " . $ticketID;
						break;
					
					case "customer_id";
					case "assigned_engineer_id";
						// number
						$updateStmt .= $addStmt . "`" . $name . "` = " . sqlFormatNumber($value);
						$addStmt = ",";
						break;
				}
       		}
       	}
       	$query = "UPDATE st_tickets SET " .  $updateStmt . " WHERE " . $updateCondition;

		// -- Exec query --
		$result = mysql_query($query);
		if ($result) {
			$rarg = $ticketID;
			$ticketIDforNote = $rarg;
			$rcode = 1;
		} else {
			$rarg = 0;			
		}

	}
	// -- process "insert" operation --
	else if ($operation == "insert") {

    	$valuesNode = $nodeOperation->getElementsByTagName("values");
    	$valueNode = $valuesNode->item(0);
     	
		// -- Create the insert statement --
		$insertNames = "";
		$insertValues = "";

		if ($valueNode->hasAttributes()) {
			$addStmt = "";
			foreach ($valueNode->attributes as $attribute) {
				$name = $attribute->name;
				$value = $attribute->value;

				switch ($name) {
					case "description";
					case "status";
					case "action";
					case "priority";
					case "product_name";
					case "product_version";
					case "product_language";
					case "disposition";
					case "summary";
					case "operating_system";	
					case "web_server";
					case "web_browser";
					case "app_server";
						// string
						$insertNames = 	$insertNames . $addStmt . "`" . $name . "`";	
						$insertValues = $insertValues . $addStmt . sqlFormatString($value); 
						$addStmt = ",";
						break;

					case "create_dt";
						// date
						$insertNames = 	$insertNames . $addStmt . "`" . $name . "`";	
						$insertValues = $insertValues . $addStmt . sqlFormatString($value); 
						$addStmt = ",";
						break;
						
					case "customer_id";
					case "assigned_engineer_id";
						// number
						$insertNames = 	$insertNames . $addStmt . "`" . $name . "`";	
						$insertValues = $insertValues . $addStmt . sqlFormatNumber($value);
						$addStmt = ",";
						break;
				}
			}
		}

		$query = "INSERT INTO st_tickets (" .  $insertNames . ") VALUES (" . $insertValues . ")"; 
		
		// -- Exec query --
		$result = mysql_query($query);
		if ($result) {
			//$num_rows = mysql_affected_rows();
			$rarg = mysql_insert_id();
			$ticketIDforNote = $rarg;
			$rcode = 1;
		} else {
			$rarg = 0;			
		}

	} else {
		$operation = "badoperation";
	}
	// ----- Create Note  -----	
    $valuesNode = $nodeOperation->getElementsByTagName("tnote");

	if ($rcode == 1 && $ticketIDforNote > 0 && $valuesNode->length > 0) {

    	$valueNode = $valuesNode->item(0);
    	  	
		// -- Create the insert statement --
		$insertNames = "";
		$insertValues = "";

		if ($valueNode->hasAttributes()) {
			$addStmt = "";
			foreach ($valueNode->attributes as $attribute) {
				$name = $attribute->name;
				$value = $attribute->value;

				switch ($name) {
					case "note";
						// string
						$insertNames = 	$insertNames . $addStmt . "`" . $name . "`";	
						$insertValues = $insertValues . $addStmt . sqlFormatString($value); 
						$addStmt = ",";
						break;

					case "date_entered";
						// date
						$insertNames = 	$insertNames . $addStmt . "`" . $name . "`";	
						$insertValues = $insertValues . $addStmt . sqlFormatString($value); 
						$addStmt = ",";
						break;
						
					case "engineer_id";
						// number
						$insertNames = 	$insertNames . $addStmt . "`" . $name . "`";	
						$insertValues = $insertValues . $addStmt . sqlFormatNumber($value);
						$addStmt = ",";
						break;
				}
			}
			$insertNames = 	$insertNames . $addStmt . "`ticket_id`";	
			$insertValues = $insertValues . $addStmt . sqlFormatNumber($ticketIDforNote); 			
		}

		$query = "INSERT INTO st_ticket_notes (" .  $insertNames . ") VALUES (" . $insertValues . ")"; 
		
		// -- Exec query --
		$result = mysql_query($query);
		if ($result) {
			//$num_rows = mysql_affected_rows();
			$noteid = mysql_insert_id();
		} else {
			$noteid = -2;			
		}
	}
    	
	mysql_close();
	
	// ----- Send XML -----	
	$rootNode->setAttribute("operation", $operation);
	$rootNode->setAttribute("rcode", $rcode);	
	$rootNode->setAttribute("rarg", $rarg);	
	$rootNode->setAttribute("noteid", $noteid);	
	$rootNode->setAttribute("errmsg", $errmsg);
	
	// print the XML 
	print $dom->saveXML();
?>
