drop table if exists st_products;
drop table if exists st_languages;
drop table if exists st_engineers;
drop table if exists st_customers;
drop table if exists st_customer_engineer_map;
drop table if exists st_tickets;
drop table if exists st_ticket_notes;



create table if not exists st_products
	(name varchar(60),
	 versions varchar(255));

truncate table st_products;

insert into st_products set name="Support Ticket in PHP", versions="1.0";
insert into st_products set name="Enterprise Product", versions="1.0,1.5";
insert into st_products set name="Web Builder", versions="1.5,2.0";
insert into st_products set name="Photo Editor", versions="1.1,1.4,2.0";
insert into st_products set name="Data Services", versions="1.0,2.0";
insert into st_products set name="Messaging", versions="2.0";
insert into st_products set name="Video Streaming", versions="1.0,1.5,2.0";
insert into st_products set name="Word Processing", versions="1.0,1.5,1.5u1";


create table if not exists st_languages
	(name varchar(80));

truncate table st_languages;

insert into st_languages set name="Chinese (Simple)";
insert into st_languages set name="Chinese (Traditional)";
insert into st_languages set name="English";
insert into st_languages set name="French";
insert into st_languages set name="German";
insert into st_languages set name="Italian";
insert into st_languages set name="Japanese";
insert into st_languages set name="Korean";
insert into st_languages set name="Portuguese";
insert into st_languages set name="Spanish";
insert into st_languages set name="Swedish";

create table if not exists st_engineers
	(id integer primary key,
	 name varchar(40),
	 title varchar(40) null default '',
	 email varchar(40),
	 phone varchar(30) null default '');
	 
truncate table st_engineers;

insert into st_engineers 
	set id=50, name='PhilFlash', email='philflash@inway.fr',
            title='Senior Flex Engineer', phone='+33 1.42.56.41.57';	 
insert into st_engineers 
	set id=100, name='George Washington', email='gwashington@yourcorp.com',
            title='Senior Support Engineer', phone='800 219-9991';
insert into st_engineers 
	set id=101, name='Thomas Jefferson', email='tjefferson@yourcorp.com',
            title='Support Manager', phone='800 219-9992';
insert into st_engineers 
	set id=102, name='Abraham Lincoln', email='alincoln@yourcorp.com',
            title='Support Engineer', phone='800 219-9993';
insert into st_engineers 
	set id=103, name='Alexander Hamilton', email='ahamilton@yourcorp.com',
            title='Support Engineer', phone='800 219-9994';
insert into st_engineers 
	set id=104, name='Benjamin Franklin', email='bfranklin@yourcorp.com',
            title='Support Engineer', phone='800 219-9995';
insert into st_engineers 
	set id=105, name='US Grant', email='ugrant@yourcorp.com',
            title='Senior Support Engineer', phone='800 219-9996';
insert into st_engineers 
	set id=106, name='Andrew Jackson', email='ajackson@yourcorp.com',
            title='Support Engineer', phone='800 219-9997';
insert into st_engineers 
	set id=107, name='James Monroe', email='jmonroe@yourcorp.com',
            title='Support Engineer', phone='800 219-9998';
insert into st_engineers 
	set id=108, name='Zachary Taylor', email='ztaylor@yourcorp.com',
            title='Support Engineer', phone='800 219-9999';

	 
create table if not exists st_customers
	(id integer primary key,
	 company varchar(60),
	 status varchar(12),
	 contact_name varchar(40),
	 contact_email varchar(40),
	 contact_phone varchar(30) null default '',
	 contact_address1 varchar(40) null default '',
	 contact_address2 varchar(40) null default '',
	 contact_address3 varchar(40) null default '',
	 contact_address4 varchar(40) null default '');

truncate table st_customers;
	 
insert into st_customers
	set id=500, company='Adobe France', status='active', contact_name='Florent Pajani', 	contact_email='fpajani@adobe.com',
	contact_phone='+33 1 56 54 99 00', contact_address1='Tour Maine Montparnasse', contact_address2='33, avenue du Maine', contact_address3='BP 14', contact_address4='75755 Paris Cedex 15';
insert into st_customers	
	set id=1000, company='Adobe Systems', status='active', contact_name='Peter Ent', 	contact_email='pent@adobe.com',
	contact_phone='617 219-2294', contact_address1='275 Grove St.', contact_address2='Newton, MA 02664';	 
insert into st_customers
	set id=1001, company='Greenspace', status='active', contact_name='Bob Smith', 	contact_email='bsmith@greenspace.com',
	contact_phone='408 555-1989', contact_address1='500 Market St.', contact_address2='MS 708', 	contact_address3='San Francisco, CA 99999';	 
insert into st_customers
	set id=2000, company='Jeopardy Railways', status='active', contact_name='Julie Gates', 	contact_email='jgates@jeopardyrail.com',
	contact_phone='999 555-0909', contact_address1='Trans-Kansas Bldg', contact_address2='1000 Main St.', 	contact_address3='Topeka, KA 99999';	 
insert into st_customers
	set id=2200, company='Pandemonium Airlines', status='active', contact_name='Jorge Arroyo', 	contact_email='jorge.arroyo@pandemair.com',
	contact_phone='212 555-7888', contact_address1='400 Columbus Ave', contact_address2='New York, NY 10019';	insert into st_customers
	set id=3000, company='The College Fund', status='active', contact_name='Lester Connell', 	contact_email='lconnell@college.edu',
	contact_phone='315 555-1000', contact_address1='650 Erie Blvd', contact_address2='Syracuse, NY 13290';	 
insert into st_customers
	set id=3300, company='Ivanna Newhouse, Real Estate', status='active', contact_name='Marcia Miami', 	contact_email='marcia@ivannanewhouse.com',
	contact_phone='609 434-3993', contact_address1='7800 State Street', contact_address2='8th Floor', 	contact_address3='Trenton, NJ 08621';
insert into st_customers
	set id=3301, company='Lickety-Split Ventures', status='30days', contact_name='Hugo Dross',
	contact_email="hdross@licketysplit.net",
	contact_phone='212 555-9898', contact_address1='2400 6th Ave', contact_address2='LSV, Inc', 
	contact_address3='New York, NY 10019';
insert into st_customers
	set id=3598, company='Smogg View Systems', status='expired', contact_name='Grant Treshcher',
	contact_email='gtresh@smogg.com',
	contact_phone='305 899-0494', contact_address1='2105 SW 134th St', contact_address2='Miami, FL',
	contact_address3='33501';
insert into st_customers
	set id=4201, company='Ouch! Pharmacuticals', status='30days', contact_name='Leslie Hall',
	contact_email='lhall@ouchpharm.com',
	contact_phone='none given',
	contact_address1='920 Oak Park Lane Drive', contact_address2='Springfield, IL 61691';
insert into st_customers
	set id=4500, company='Blue Spaghetti Foods', status='active', contact_name='Brenda DuBois',
	contact_email='bdubois@bluespaghettifoods.com',
	contact_phone='419 555-0909', contact_address1='80 Heron Blvd', contact_address2='Toronto, CA 4R2J7M';
insert into st_customers
	set id=5103, company='2x Lightning', status='30days', contact_name='Etienne Champaneux',
	contact_email='echamp@xxl.net',
	contact_phone='818 555-0983', contact_address1='Royal Palm Business Center',
	contact_address2='80 Royal Palm Blvd', contact_address3='Suite 415',
	contact_address4='West Palm Beach, FL 33604';
insert into st_customers
	set id=5155, company='Big Giant Media', status='expired', contact_name='Earl Udani',
	contact_email='earl@bgmx.net',
	contact_address1='500 Apex Way',contact_address2='Denver, CO 45003';
insert into st_customers
	set id=5230, company='Kentucky State College', status='active', contact_name='Erin Fastway',
	contact_email='efastway@kentucky.edu',
	contact_phone='800 566-3944',
	contact_address1='1 University Way', contact_address2='Lexington, KY 29901';
insert into st_customers
	set id=5280, company='Max Out', status='expired', contact_name='Max Outfielder',
	contact_email='max@maxout.com',
	contact_phone='866 299-9999',contact_address1='19 Elm Ct', contact_address2='Syracuse, NY 13210';

	


create table if not exists st_customer_engineer_map
	(engineer_id integer,
	 customer_id integer);

truncate table st_customer_engineer_map;

insert into st_customer_engineer_map set engineer_id=50, customer_id=500;
insert into st_customer_engineer_map set engineer_id=50, customer_id=1000;

insert into st_customer_engineer_map set engineer_id=100, customer_id=1000;
insert into st_customer_engineer_map set engineer_id=100, customer_id=5155;
insert into st_customer_engineer_map set engineer_id=101, customer_id=1001;
insert into st_customer_engineer_map set engineer_id=101, customer_id=5230;
insert into st_customer_engineer_map set engineer_id=102, customer_id=2000;
insert into st_customer_engineer_map set engineer_id=102, customer_id=5280;
insert into st_customer_engineer_map set engineer_id=103, customer_id=2200;
insert into st_customer_engineer_map set engineer_id=104, customer_id=3000;
insert into st_customer_engineer_map set engineer_id=105, customer_id=3300;
insert into st_customer_engineer_map set engineer_id=107, customer_id=3301;
insert into st_customer_engineer_map set engineer_id=108, customer_id=3598;
insert into st_customer_engineer_map set engineer_id=108, customer_id=4201;
insert into st_customer_engineer_map set engineer_id=100, customer_id=4500;
insert into st_customer_engineer_map set engineer_id=101, customer_id=5103;



create table if not exists st_tickets
	(id integer auto_increment primary key,
	 customer_id integer,
	 create_dt timestamp DEFAULT CURRENT_TIMESTAMP,
	 assigned_engineer_id integer,
	 description varchar(200),
	 status varchar(20),
	 action varchar(20),
	 priority varchar(20),
	 product_name varchar(40),
	 product_version varchar(20),
	 product_language varchar(20),
	 operating_system varchar(30),
	 web_browser varchar(30),
	 web_server varchar(30),
	 app_server varchar(30),
	 disposition varchar(35),
	 summary text);

truncate table st_tickets;


INSERT INTO `st_tickets` (`customer_id`, `create_dt`, `assigned_engineer_id`, `description`, `status`, `action`, `priority`, `product_name`, `product_version`, `product_language`, `operating_system`, `web_browser`, `web_server`, `app_server`, `disposition`, `summary`) 
VALUES (1000, '2006-11-13 19:05:19', 50, 'Demo Mystic Support by PhilFlash', 'Open', 'Customer Contacted', '15', 'Support Ticket in PHP', '1.0', 'English', '', '', '', '', '', '13 nov 2006 :\r- initial version in PHP5 with MySQL');


create table if not exists st_ticket_notes
	 (id integer auto_increment primary key,
	  ticket_id integer,
	  engineer_id integer,
	  date_entered datetime,
	  note text);

truncate table st_ticket_notes;

